﻿Imports TimeTag

Public Class Form1

    Dim myTagger As TTInterface
    Dim mylogic As Logic
    Dim Resolution As Double
    Dim Errors As Integer


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim Singles1, Singles2, Coincidences As Integer
        Dim FPGA_v, TimerCounter As Double

        'open connection to device
        myTagger = New TTInterface
        myTagger.Open()

        'get some basic info and display
        Resolution = myTagger.GetResolution()
        FPGA_v = myTagger.GetFpgaVersion()
        MsgBox("FPGA Version: " & FPGA_v.ToString & vbCrLf & _
               "Timing Resolution: " & Resolution.ToString & " s" & vbCrLf & vbCrLf & vbCrLf & _
               vbTab & vbTab & "Start Measurment Now?")

        'set input thresholds for channel 1 and 2
        myTagger.SetInputThreshold(1, 0.3)
        myTagger.SetInputThreshold(2, 0.3)

        'initiate logic mode
        mylogic = New Logic(myTagger)
        mylogic.SwitchLogicMode()

        'conicidence window (in units of 156ps)
        mylogic.SetWindowWidth(20)

        'count events for  1 sec:
        'take a first snapshot of counters
        mylogic.ReadLogic()

        'delay thread for abuot 0.5sec
        Threading.Thread.Sleep(500)

        'take second snapshot of counters
        mylogic.ReadLogic()

        'read true duration of measurment between the two ReadLogic comands, in multiples of 5ns. We multiply by 5ns to obtain sec
        TimerCounter = mylogic.GetTimeCounter() * 0.000000005

        'retrive observed counts for singles 1,2 and  coincidences 1&2
        singles1 = mylogic.CalcCountPos(1)
        singles2 = mylogic.CalcCountPos(2)
        Coincidences = mylogic.CalcCountPos(3)

        'show  data
        MsgBox("Measurment Time: " & vbTab & vbTab & TimerCounter.ToString("F4") & " s" & vbCrLf & _
               "Singles Events, C1:" & vbTab & vbTab & Singles1.ToString & vbCrLf & _
               "Singles Events, C2:" & vbTab & vbTab & Singles2.ToString & vbCrLf & _
               "Coincidence Events, C1&C2:  " & vbTab & Coincidences.ToString & vbCrLf & _
               "----------------------------------" & vbCrLf & _
               "Singles Rate, C1:" & vbTab & vbTab & (Singles1 / TimerCounter).ToString("F1") & " cps" & vbCrLf & _
               "Singles Rate, C2:" & vbTab & vbTab & (Singles2 / TimerCounter).ToString("F1") & " cps" & vbCrLf & _
               "Coincidence Rate, C1&C2:  " & vbTab & (Coincidences / TimerCounter).ToString("F1") & " cps")



        Close()

    End Sub


    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        MsgBox("Thanks for testing the counter. Bye")

        ' close connection to device
        myTagger.Close()

    End Sub
   
End Class







